package cn.com.ctop.job.bytedance.handler;

import cn.com.ctop.common.module.entity.CtopOauthToken;
import cn.com.ctop.common.module.service.ICtopOauthTokenService;
import cn.com.ctop.toutiao.modules.report.service.IBytedanceInterfaceService;
import com.xxl.job.core.context.XxlJobHelper;
import com.xxl.job.core.handler.annotation.XxlJob;
import org.jeecg.common.util.DateUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.Date;
import java.util.List;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

@Component
public class BytedanceDailyPlayableReportJob {
    static ExecutorService executorService = Executors.newFixedThreadPool(4);
    @Autowired
    private ICtopOauthTokenService tokenService;
    @Autowired
    private IBytedanceInterfaceService bytedanceInterfaceService;

    @XxlJob("bytedanceDailyPlayableReportJob")
    public void execute() throws Exception {
        Date getDate2 = DateUtils.addDay(new Date(), -2);
        String date2 = DateUtils.formatDate(getDate2);

        Date getDate = DateUtils.addDay(new Date(), -1);
        String date = DateUtils.formatDate(getDate);
        XxlJobHelper.log("头条获取试玩报表数据任务开始，任务时间：" + date2 + "~" + date);

        List<CtopOauthToken> tokens = tokenService.selectToutiaoToken();
        if (null == tokens || tokens.size() <= 0) {
            XxlJobHelper.log("头条获取试玩报表数据任务执行失败:未获取到可用的token");
            XxlJobHelper.handleFail();
            return ;
        }

        tokens.forEach(token -> {
            executorService.submit(new Runnable() {
                @Override
                public void run() {
                    try {
                        //获取头条素材报表两天前的数据
                        XxlJobHelper.log("账户"+token.getAccountId() + "试玩报表数据任务开始，任务时间：" + date2 + "~" + date2);
                        bytedanceInterfaceService.bytedancePlayableReport(token, date2, date2);
                        XxlJobHelper.log("账户"+token.getAccountId() + "试玩报表数据任务完成，任务时间：" + date2 + "~" + date2);

                        //获取头条素材报表数据
                        XxlJobHelper.log("账户"+token.getAccountId() + "试玩报表数据任务开始，任务时间：" + date + "~" + date);
                        bytedanceInterfaceService.bytedancePlayableReport(token, date, date);
                        XxlJobHelper.log("账户"+token.getAccountId() + "试玩报表数据任务完成，任务时间：" + date + "~" + date);
                    } catch (Exception e) {
                        e.printStackTrace();
                    } finally {
                    }
                }
            });
        });
    }



}
